<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_flower
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.multiselect');

$user	= JFactory::getUser();
$userId	= $user->get('id');

$function	= JRequest::getCmd('function', 'jSelectArticle');
$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$canOrder	= $user->authorise('core.edit.state', 'com_flower');
$saveOrder	= $listOrder == 'a.ordering';
$nested 	= false ;
$filter		= JRequest::getVar('filter') ;

if( JVERSION >= 3 ) {
	JHtml::_('formbehavior.chosen', 'select');
}

$lang = JFactory::getLanguage();
$lang->load('com_modules');

?>

<form action="<?php echo $uri = JFactory::getURI()->toString() ; ?>" method="post" name="adminForm" id="adminForm">

	
	<div id="filter-bar" class="btn-toolbar">
		<!-- Search Input -->
		
		<div class="btn-group pull-left fltlft">
			<?php
				$field = $this->filter['search']->getField('field') ;
				echo $field->label . ' ' ;
			?>
		</div>
		
		<div class="btn-group pull-left fltlft">
			<?php
				if( !$this->state->get('search.fulltext') ){
					echo $field->input ;
				}
			?>
		</div>
		
		<div class="btn-group pull-left fltlft">
			<?php 
				$index = $this->filter['search']->getField('index') ;
				echo $index->input ;
			?>
		</div>
		
		
		<!-- Search Button -->
		<?php if( JVERSION >= 3 ): ?>
		<div class="btn-group pull-left hidden-phone">
			<button class="btn tip hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
			<button class="btn tip hasTooltip" type="button" onclick="document.id('search_index').value='';this.form.submit();" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>"><i class="icon-remove"></i></button>
		</div>
		<?php else: ?>
		
			<button type="btn submit"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
			<button type="btn button" onclick="document.id('search_index').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
		
		<?php endif; ?>
		
		
		<div class="btn-group pull-right">
			<select name="filter[b.client_id]" id="sortTable" class="input-medium" onchange="Joomla.submitform()">
				<option value="0" <?php echo $filter['b.client_id'] == 0 ? 'selected' : ''; ?>><?php echo JText::_('JSITE');?></option>
				<option value="1" <?php echo $filter['b.client_id'] == 1 ? 'selected' : ''; ?>><?php echo JText::_('JADMINISTRATOR');?></option>
			</select>
		</div>
		
	</div>

	<table class="adminlist table table-striped">
		<thead>
			<tr>
				
				<th>
					<?php echo JHtml::_('grid.sort',  'JGLOBAL_TITLE', 'a.title', $listDirn, $listOrder); ?>
				</th>
				
				<th width="15%">
					<?php echo JHtml::_('grid.sort',  'JSITE', 'b.client_id', $listDirn, $listOrder); ?>
				</th>
				
				<th width="10%">
					<?php echo JHtml::_('grid.sort',  'COM_MODULES_HEADING_POSITION', 'a.position', $listDirn, $listOrder); ?>
				</th>
				
				<th width="15%">
					<?php echo JHtml::_('grid.sort',  'COM_MODULES_HEADING_MODULE', 'b.name', $listDirn, $listOrder); ?>
				</th>
				
                <th width="1%" class="nowrap">
                    <?php echo JHtml::_('grid.sort',  'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
                </th>

			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="10">
					<?php //echo $this->pagination->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody>
		<?php foreach ($this->items as $i => $item) :
			
			$client = 'site' ;
			$extension = $item->module;
			$source = constant('JPATH_' . strtoupper($client)) . "/modules/$extension";
				$lang->load("$extension.sys", constant('JPATH_' . strtoupper($client)), null, false, false)
			||	$lang->load("$extension.sys", $source, null, false, false)
			||	$lang->load("$extension.sys", constant('JPATH_' . strtoupper($client)), $lang->getDefault(), false, false)
			||	$lang->load("$extension.sys", $source, $lang->getDefault(), false, false);
			$item->name = JText::_($item->name);
			
			$client = 'administrator' ;
			$extension = $item->module;
			$source = constant('JPATH_' . strtoupper($client)) . "/modules/$extension";
				$lang->load("$extension.sys", constant('JPATH_' . strtoupper($client)), null, false, false)
			||	$lang->load("$extension.sys", $source, null, false, false)
			||	$lang->load("$extension.sys", constant('JPATH_' . strtoupper($client)), $lang->getDefault(), false, false)
			||	$lang->load("$extension.sys", $source, $lang->getDefault(), false, false);
			$item->name = JText::_($item->name);
			
			
			
			$item = new JObject($item);
			
			$ordering	= ($listOrder == 'a.ordering');
			$canCreate	= $user->authorise('core.create',		'com_flower');
			$canEdit	= $user->authorise('core.edit',			'com_flower.sakura.'.$item->id);
			$canCheckin	= $user->authorise('core.manage',		'com_flower.sakura.'.$item->id) || $item->checked_out == $userId || $item->checked_out == 0;;
			$canChange	= $user->authorise('core.edit.state',	'com_flower.sakura.'.$item->id) && $canCheckin;
			
			if($nested && $item->id == 1){
				$item->title = JText::_('JGLOBAL_ROOT') ;
			}
			?>
			<tr class="row<?php echo $i % 2; ?>">
				
				<td>
					
					<!-- Title -->
					<?php if( $canEdit): ?>
					<a class="pointer" style="cursor: pointer;"
					   onclick="if (window.parent) window.parent.<?php echo $this->escape($function);?>('<?php echo $item->link; ?>','<?php echo $this->escape(addslashes($item->title)); ?>');"
						
					>
						<?php echo JText::_($this->escape($item->title)); ?></a>
					<?php else: ?>
						<?php echo $this->escape($item->title); ?>
					<?php endif; ?>

					<?php if (!empty($item->note)) : ?>
						<div class="small">
							<?php echo JText::sprintf('JGLOBAL_LIST_NOTE', $this->escape($item->note));?>
						</div>
					<?php endif; ?>
				</td>
				
				<td class="center">
					<?php echo $item->client_id ? JText::_('JADMINISTRATOR') : JText::_('JSITE'); ?>
				</td>
				
				<td class="center">
					<?php if ($item->position) : ?>
						<span class="label label-info">
							<?php echo $item->position; ?>
						</span>
					<?php else : ?>
						<span class="label">
							<?php echo JText::_('JNONE'); ?>
						</span>
					<?php endif; ?>
				</td>
				
				<td class="center">
					<?php echo $item->name;?>
				</td>

				<td class="center">
					<span
						<?php if( $nested ): ?>
						class="hasTip hasTooltip" title="<?php echo $item->lft.'-'.$item->rgt; ?>"
						<?php endif; ?>
					><?php echo (int) $item->get('id'); ?></span>	
				</td>
   
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	
	<div>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
	</div>
</form>