<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_flower
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.multiselect');

$user	= JFactory::getUser();
$userId	= $user->get('id');

$function	= JRequest::getCmd('function', 'jSelectArticle');
$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$canOrder	= $user->authorise('core.edit.state', 'com_flower');
$saveOrder	= $listOrder == 'a.ordering';
$nested		= $this->state->get('items.nested') ;
$show_root	= JRequest::getVar('show_root') ;

if( JVERSION >= 3 ) {
	JHtml::_('formbehavior.chosen', 'select');
}

$lang = JFactory::getLanguage();
$lang->load('com_plugins');

?>

<form action="<?php echo $uri = JFactory::getURI()->toString() ; ?>" method="post" name="adminForm" id="adminForm">

	
	<div id="filter-bar" class="btn-toolbar">
		<!-- Search Input -->
		
		<div class="btn-group pull-left fltlft">
			<?php
				$field = $this->filter['search']->getField('field') ;
				echo $field->label . ' ' ;
			?>
		</div>
		
		<div class="btn-group pull-left fltlft">
			<?php
				if( !$this->state->get('search.fulltext') ){
					echo $field->input ;
				}
			?>
		</div>
		
		<div class="btn-group pull-left fltlft">
			<?php 
				$index = $this->filter['search']->getField('index') ;
				echo $index->input ;
			?>
		</div>
		
		
		<!-- Search Button -->
		<?php if( JVERSION >= 3 ): ?>
		<div class="btn-group pull-left hidden-phone">
			<button class="btn tip hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
			<button class="btn tip hasTooltip" type="button" onclick="document.id('search_index').value='';this.form.submit();" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>"><i class="icon-remove"></i></button>
		</div>
		<?php else: ?>
		
			<button type="btn submit"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
			<button type="btn button" onclick="document.id('search_index').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
		
		<?php endif; ?>
	</div>

	<table class="adminlist table table-striped">
		<thead>
			<tr>
				
				<th>
					<?php echo JHtml::_('grid.sort',  'COM_PLUGINS_NAME_HEADING', 'a.name', $listDirn, $listOrder); ?>
				</th>
				
				<th width="10%">
					<?php echo JHtml::_('grid.sort',  'COM_PLUGINS_FOLDER_HEADING', 'a.folder', $listDirn, $listOrder); ?>
				</th>
				
				<th width="15%">
					<?php echo JHtml::_('grid.sort',  'COM_PLUGINS_ELEMENT_HEADING', 'a.element', $listDirn, $listOrder); ?>
				</th>
				
                <th width="1%" class="nowrap">
                    <?php echo JHtml::_('grid.sort',  'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
                </th>

			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="10">
					<?php //echo $this->pagination->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody>
		<?php foreach ($this->items as $i => $item) :
			
			$source = JPATH_PLUGINS . '/' . $item->folder . '/' . $item->element;
			$extension = 'plg_' . $item->folder . '_' . $item->element;
				$lang->load($extension . '.sys', JPATH_ADMINISTRATOR, null, false, false)
			||	$lang->load($extension . '.sys', $source, null, false, false)
			||	$lang->load($extension . '.sys', JPATH_ADMINISTRATOR, $lang->getDefault(), false, false)
			||	$lang->load($extension . '.sys', $source, $lang->getDefault(), false, false);
			$item->title = JText::_($item->title);
			
			
			$item = new JObject($item);
			
			$ordering	= ($listOrder == 'a.ordering');
			$canCreate	= $user->authorise('core.create',		'com_flower');
			$canEdit	= $user->authorise('core.edit',			'com_flower.sakura.'.$item->id);
			$canCheckin	= $user->authorise('core.manage',		'com_flower.sakura.'.$item->id) || $item->checked_out == $userId || $item->checked_out == 0;;
			$canChange	= $user->authorise('core.edit.state',	'com_flower.sakura.'.$item->id) && $canCheckin;
			
			if($nested && $item->id == 1){
				$item->title = JText::_('JGLOBAL_ROOT') ;
			}
			?>
			<tr class="row<?php echo $i % 2; ?>">
				
				<td>
					
					<!-- Title -->
					<?php if( $canEdit): ?>
					<a class="pointer" style="cursor: pointer;"
					   onclick="if (window.parent) window.parent.<?php echo $this->escape($function);?>('<?php echo $item->link; ?>','<?php echo $this->escape(addslashes($item->title)); ?>');"
						
					>
						<?php echo $this->escape($item->title); ?></a>
					<?php else: ?>
						<?php echo $this->escape($item->title); ?>
					<?php endif; ?>

					<?php if (!empty($item->note)) : ?>
						<div class="small">
							<?php echo JText::sprintf('JGLOBAL_LIST_NOTE', $this->escape($item->note));?>
						</div>
					<?php endif; ?>
				</td>
				
				<td class="center">
					<?php echo $item->folder; ?>
				</td>
				
				<td class="center">
					<?php echo $item->element;?>
				</td>

				<td class="center">
					<span
						<?php if( $nested ): ?>
						class="hasTip hasTooltip" title="<?php echo $item->lft.'-'.$item->rgt; ?>"
						<?php endif; ?>
					><?php echo (int) $item->get('id'); ?></span>	
				</td>
   
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	
	<div>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
	</div>
</form>