<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_akquickicons
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

include_once AKPATH_COMPONENT.'/viewlist.php' ;

/**
 * View class for a list of Akquickicons.
 */
class AkquickiconsViewIcons extends AKViewList
{
	/**
	 * @var		string	The prefix to use with controller messages.
	 * @since	1.6
	 */
	protected 	$text_prefix = 'COM_AKQUICKICONS';
	protected 	$items;
	protected 	$pagination;
	protected 	$state;
	
	public		$option 	= 'com_akquickicons' ;
	public		$list_name 	= 'icons' ;
	public		$item_name 	= 'icon' ;
	public		$sort_fields ;

	
	
	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$app = JFactory::getApplication() ;
		
		// For Modal
		if( JRequest::getVar('layout') == 'modal' ) {
			
			$select = JRequest::getVar('select', 'icon') ;
			$method = 'modal'.ucfirst($select) ;
			
			$this->state		= $this->get('State');
			$this->items 		= $this->get($select);
			$this->pagination	= $this->get('Pagination');
			$this->filter		= $this->get('Filter');
			
			
			parent::display($select);
			return true;
		}
		
		// For Item list
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->filter		= $this->get('Filter');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		parent::displayWithPanel($tpl);
	}

	
	
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		// Set title.
		AKToolBarHelper::title( JText::_($this->text_prefix.'_TITLE_ICONS'), 'article.png');
		
		parent::addToolbar();
	}
	
	
	/**
	 * Returns an array of fields the table can be sorted by
	 *
	 * @return  array  Array containing the field name to sort by as the key and display text as value
	 *
	 * @since   3.0
	 */
	protected function getSortFields()
	{
		$ordering_key = $this->state->get('items.nested') ? 'a.lft' : 'a.ordering' ;
		
		$this->sort_fields = array(
			$ordering_key 		=> JText::_('JGRID_HEADING_ORDERING'),
			'a.published' 		=> JText::_('JPUBLISHED'),
			'a.title' 			=> JText::_('JGLOBAL_TITLE'),
			'b.title' 			=> JText::_('JCATEGORY'),
			'd.title' 			=> JText::_('JGRID_HEADING_ACCESS'),
			'a.created_by' 		=> JText::_('JAUTHOR'),
			'e.title' 			=> JText::_('JGRID_HEADING_LANGUAGE'),
			'a.created' 		=> JText::_('JDATE'),
			'a.id' 				=> JText::_('JGRID_HEADING_ID')
		);
		
		return $this->sort_fields ;
	}
}
