<?php
/**
 * @package     Windwalker.Framework
 * @subpackage  class
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

/**
 * Supports a modal picker.
 */
class JFormFieldModal extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'Modal';
	
	protected $view_list ;
	
	protected $view_item ;
	
	protected $extension ;
	
	protected $component ;
	
	
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput()
	{
		// Load the modal behavior script.
		JHtml::_('behavior.modal', 'a.modal');
		$this->setElement();
		

		// Build the script.
		$script = array();
		$script[] = '	function jSelect'.ucfirst($this->component).'_'.$this->id.'(id, title) {';
		$script[] = '		document.id("'.$this->id.'_id").value = id;';
		$script[] = '		document.id("'.$this->id.'_name").value = title;';
		$script[] = '		SqueezeBox.close();';
		$script[] = '	}';

		// Add the script to the document head.
		JFactory::getDocument()->addScriptDeclaration(implode("\n", $script));


		// Setup variables for display.
		$html	= array();
		$link	= $this->getLink();

		$title = $this->getTitle();

		if (empty($title)) {
			$title = JText::_('COM_'.strtoupper($this->component).'_SELECT_ITEM');
		}
		$title = htmlspecialchars($title, ENT_QUOTES, 'UTF-8');
		
		if( JVERSION >=3 ){
			// The current user display field.
			$html[] = '<span class="input-append">';
			$html[] = '<input type="text" class="input-medium" id="'.$this->id.'_name" value="'.$title.'" disabled="disabled" size="35" /><a class="modal btn" title="'.JText::_('COM_'.strtoupper($this->component).'_CHANGE_ITEM_BUTTON').'"  href="'.$link.'&amp;'.JSession::getFormToken().'=1" rel="{handler: \'iframe\', size: {x: 800, y: 450}}"><i class="icon-file"></i> '.JText::_('JSELECT').'</a>';
			$html[] = '</span>';
		}else{
			// The current user display field.
			$html[] = '<div class="fltlft">';
			$html[] = '  <input type="text" id="'.$this->id.'_name" value="'.$title.'" disabled="disabled" size="35" />';
			$html[] = '</div>';
	
			// The user select button.
			$html[] = '<div class="button2-left">';
			$html[] = '  <div class="blank">';
			$html[] = '	<a class="modal" title="'.JText::_('COM_'.strtoupper($this->component).'_CHANGE_ITEM').'"  href="'.$link.'&amp;'.JSession::getFormToken().'=1" rel="{handler: \'iframe\', size: {x: 800, y: 450}}">'.JText::_('COM_'.strtoupper($this->component).'_CHANGE_ITEM_BUTTON').'</a>';
			$html[] = '  </div>';
			$html[] = '</div>';
		}
		

		// The active article id field.
		if (0 == (int)$this->value) {
			$value = '';
		} else {
			$value = (int)$this->value;
		}

		// class='required' for client side validation
		$class = '';
		if ($this->required) {
			$class = ' class="required modal-value"';
		}

		$html[] = '<input type="hidden" id="'.$this->id.'_id"'.$class.' name="'.$this->name.'" value="'.$value.'" />';

		return implode("\n", $html);
	}
	
	
	/*
	 * function setElement
	 * @param 
	 */
	
	public function setElement()
	{
		$view_item = (string) $this->element['view_item'] ;
		$view_list = (string) $this->element['view_list'] ;
		$extension = (string) $this->element['extension'] ;
		
		if(!empty($view_item)){
			$this->view_item = $view_item ;
		}
		
		if(!empty($view_list)){
			$this->view_list = $view_list ;
		}
		
		if(!empty($extension)){
			$this->extension = $extension ;
		}
		
		$this->component = str_replace('com_', '', $this->extension );
	}
	
	
	/*
	 * function getTitle
	 * @param 
	 */
	
	public function getTitle()
	{
		$ctrl = $this->view_list ;
		
		$db	= JFactory::getDbo();
		$q = $db->getQuery(true) ;
		
		$q->select('title')
			->from('#__'.$this->component.'_' . $ctrl)
			->where("id = '{$this->value}'")
			;
			
		$db->setQuery($q);
		$title = $db->loadResult();
		
		if ($error = $db->getErrorMsg()) {
			JError::raiseWarning(500, $error);
		}
		
		return $title ;
	}
	
	
	
	/*
	 * function getLink
	 * @param 
	 */
	
	public function getLink()
	{
		// Avoid self
		$id 	= JRequest::getVar('id') ;
		$option = JRequest::getVar('option') ;
		$view 	= JRequest::getVar('view') ;
		$layout = JRequest::getVar('layout') ;
		$params = '' ;
		
		if(isset($this->element['show_root'])) {
			$params .= '&show_root=1' ;
		}
		
		if($view == $this->view_item && $option == $this->extension && $layout == 'edit' && $id){
			$params .= '&avoid='.$id ;
		}
		
		return 'index.php?option='.$this->extension.'&view='.$this->view_list.$params.'&layout=modal&tmpl=component&function=jSelect'.ucfirst($this->component).'_'.$this->id ;
	}
}
